# COMP 206 - Winter 2025 - Assignment 5 -  Team Assignment - Files and Pointers


**Instructors:** Max Kopinsky & Joseph Vybihal  
Due: 11 April 2025, 11:59pm.


*Before you start, please read the following instructions:**  

- **GROUP assignment** 

  This is a **GROUP** assignment. There must be 3 or 4 people in your group, a group size of 2 is not permitted. Please submit the names of the people in your group by filling out this form: <a href="https://forms.office.com/r/cnDk95tWm9">Register Your Team</a>.

  In this assignment, your group will be using a shared repository. Please email Prof Joseph at joseph.vybihal@mcgill.ca to receive instructions for how to connect to the shared server account. Each team will receive their own private shared server account. In this account you will host your shared git repository. Please select one person from your group to contact Prof. Joseph for the shared account instructions. Send this email only after you filled out the form, because Prof Joseph will need information from the form.

  After each member of your team successfully connects to the shared account you will need to follow the instructions in the section called **Shared Account Instructions** for what is expected. The purpose of the shared account is to practice push, pull, branch, and merge on a shared repository. The TA will grade your group by looking at this shared repository. They will not be looking at the code in your personal mimi accounts. Everyone in the group will receive the same points.

  **NOTE**: If you are in a group of 4, then you have an additional feature to program. Students in a group of 3 do not do this additional feature. The additional feature is identified in the text of this assignment.
  
  Collaboration with your peers (people outside of your group) is permitted (and encouraged!) provided that no code is shared; discuss the ideas.  

- **Shared Account Instructions**

  Your will need to create a sharable repo in the shared account by using the command we saw in class **git init --bare** while logged into the shared account. To do this, in the home directory of the shared account create a subdirectory called **project**. CD into project and run git init --bare. Then, vim a **readme.txt** file adding the names and ID numbers of all the students in your group. Then add and commit that file to the repo. You can type git log to make sure this was done correctly. Now you are done with the shared account. Only one person from your group needs to do this. To add the readme.txt file requires the creator of the shared repo to first clone the shared repo to their local machine and add + commit the readme.txt file from there, then they must push it to the shared repo for everyone else.
  
  Now, everyone else must git clone the shared repo into their personal mimi account. Create a subdirectory in your hw5 directory called **src**. CD into the src subdirectory and run **git clone** with the URL of your shared account. If this works correctly, when you type ls -a you will see the git folder .git and the readme.txt file.

  As a team, you all will need to discuss who will work on which parts of the assignment. Divide up the work with each person in the group. In the readme.txt, please write the work that was assigned to each person in the group.

  We want to emulate what actually happens in industry when working in a group. The first step is to decide who does what. The next step is to create **branches** in the repo for the work assigned to each person. To make grading easier, please create only one branch per student and name the branch with the first name of the student. For example, assume we have a group of students named Mary Smit, Roko Etu, and Ethan Hwang. The shared repo will have the following branches: main, mary, roko, ethan. The **main** branch was automatically created when the repo was created, and might instead have the name **origin** or **master** depending on how you created it.

  Make sure to **git pull** before you start working on your local copy of the shared repo to make sure everyone has those branches.

  It is important that you do the shared work cycle we spoke about in class: (1) start your work period by doing **git pull** before you do anything to make sure you have the most recent copy. (2) do **git checkout** to work in your branch. (3) after you have created and edited files, **git add** and **git commit** these changes to your local repo in your branch. (4) when you are finished working for this period, then **git push** everything you committed in your branch to the shared repo. This will be your normal work cycle until you want your team members to see your work.

  To reveal your work to your group, you must merge the code in your branch with the main branch. You will need to do a **git merge** in your local repository. If this worked without errors, you should now compile and run the program in the main branch to make sure it works. If it does not work then fix the code in the main branch. Once it is working in the main branch, then do a **git push** to the shared repo so that everyone can see it. 

  **To get full marks, each student's branch must have more than 3 commits and more than 1 merge. The best way to ensure this happens is to pull, commit, and push often.** 

- **Submitting Your Work**

  To submit your work, just make sure that the shared repo is up to date by the due date of the assignment. You will not need to do anything else. If you want to confirm that the shared repo is in good condition, you can do the following: (1) run the program from the shared repo, (2) type **git branch** to see all the branches in the repo. It should display the main branch name and all the other branch names (the student names). There should be an asterix on the main branch. (3) You can type git log from the main and from each of the other branches to see if it looks like it was populated correctly. If these three things look at you expected, then it should be good.

- **Use Discord and OH for questions**

  If you have questions, check if they were answered in the Discord q-and-a forum. If there is no answer, post your question on the forum. Do not post your code. If your question cannot be answered without sharing significant amounts of code, please use the TA/Instructors office hours. **Do not email the TAs and Instructors with assignment questions.** TAs should only be contacted by emails if you have questions about a grade you received.


- **Late submission policy**

  You may submit up to two days late for a penalty of -10% per day. To support you submitting multiple times, you will use a form to tell us if you intend to submit late. You must submit the form by the second late deadline, that is, midnight two days after the assignment is due. Forms submitted after this date will be ignored.We will assume that you want to be graded on the actual deadline, even if you submit after the deadline, unless you fill out the form. If you fill out the form asking to be graded on a late deadline, and then change your mind, you can fill out the form again and ask for zero late days

  [Link to Form](https://forms.office.com/Pages/ResponsePage.aspx?id=cZYxzedSaEqvqfz4-J8J6jMRaTUPcwdHusCyPOG6jJFURjA0SVRLMlVFVFNZQjBOTlVTUUlWT1pJSC4u)


- **Must be completed on `mimi` server**

  You must use `mimi.cs.mcgill.ca` to create the solution to this assignment. An important objective of the course is to make students practice working completely on a remote system. You cannot use your Mac/Windows/Linux terminal/command-line prompt directly without accessing the mimi server. You can access `mimi.cs.mcgill.ca` from your personal computer using `ssh` or `putty` as seen in class and in Lab A. **If we find evidence that you have been doing parts of your assignment work elsewhere than the mimi server, you might lose all of the assignment points.** All of your solutions should be composed of commands that are executable in `mimi.cs.mcgill.ca`.


- **Must be completed with vim** 

  A goal of the class is to get you to be comfortable in a command-line text editor. This wouldn't happen just from knowing the vim commands from slides: You become comfortable by using it a lot. Assignments are a good opportunity for that.  

- **You must use commands from class** 

  In this assignment, anything in the C standard library is allowed. However, the emphasis in the assessment is on clarity and readability of the code. Do not do anything unnecessarily generalized, abstract, or complex, when simple, straightforward code suffices.  

- **Your code must run** 

  Your code must run as-is and nearly instantly. **TAs WILL NOT modify your code in any way to make it work.**  

- **Please read through the entire assignment before you start working on it** **You can lose up to 3 points for not following the instructions** in addition to the points lost per questions.  

## Obtaining and copying instructions on mimi

You might currently be reading these directions online, on GitLab. GitLab stores git repositories, collections of files (usually code) that we want to manage together. Git simplifies our lives for anything that has versions, helping us make sure that we can undo new versions that broke something, as well as effectively collaborate with others on projects. Git is one of the most useful and ubiquitous tools you will ever use, and we will talk about it more during future lectures.

Start by using git to obtain a copy of these instructions on mimi.

1. In your home directory (`~`) on Mimi, run:
   ```bash
   git clone https://gitlab.cs.mcgill.ca/mkopin/w25comp206-hw5.git
   ```
   - Git might ask for your username and password. Use your SOCS username and password.

2. You should now have a directory at `~/w25comp206-hw5`, containing this following:
   - The assignment instructions: `instructions.md` .
   - The folder `src` containing:
     -  The files `database.c`, `database.h`, `igdb.c`.
     -  A `Makefile`, which you can run via the command `make`. This will compile each C file separately and then link them together into an executable `igdb`.

3. Move the entire directory `w25comp206-hw5` into the `assignments`
  subdirectory. (As with Mini 1, Mini 2, and all other assignments, this means the
  `~/winter2025-comp206/assignments` directory that you created in Mini 1.)

1. Rename the directory `w25comp206-hw5` to `hw5`


*Note: This assignment comes with starter code.*
You should modify the files `database.c`, `database.h`, `igdb.c`, and `Makefile` from the starter code (provided within the `src` folder), providing the implementations for all the functions described below.  


## A CSV-backed database written in C  

In this assignment, your task will be to implement a command-line program called `igdb` in C for managing a persistent database stored as a CSV file. This is a simplified example of what C is actually used for in practice: writing fast, low-level data management software. The popular, high-performance, open-source relational database management system PostgreSQL is written in C, for instance.[^1]  

**Learning goals assessed:**  
1. Write robust system interactions in C.  
2. Create custom data structures and algorithms in C.  
3. Organize code in C for readability.  
4. Using the IPACS writing convension.

### What's in the database?  

The database in this assignment is for tracking Instagram accounts. One record in the database stores the following information:  
* *Handle*, e.g. `@spottedmcgill`  
* *Follower count*, e.g. `14900`  
* *Comment*, e.g. `a bit cringe tbh`  
* *Date last modified*, e.g. `1710521259`  

This record would be represented in CSV form as:  
```csv
@spottedmcgill,14900,a bit cringe tbh,1710521259
```  

To accommodate the CSV file format, the characters `'\0'` (null), `'\n'` (line feed), and `','` (comma) are forbidden from appearing in the comment field.  

### Representing dates and times  

You might have noticed that the "date last modified" above doesn't look like a date at all...  

Representing dates and times robustly can be a challenge in software engineering. A very common and straightforward solution is to represent an absolute moment in time in so-called UNIX Epoch format. This is the number of seconds elapsed since midnight on 1 January 1970. These are also called (UNIX) timestamps. This format is independent of timezones, which makes it great for storage in a database. User-facing applications convert these timestamps into human-readable "local time" strings, accounting for timezones, when displaying the time to a user.  

Your database will store UNIX timestamps, and your application must present these times in human-readable strings in the local timezone. The C standard library contains functions for working with UNIX timestamps and dates and times in general:  
* You will need to `#include <time.h>`  
* See `man 2 time` (get current timestamp)  
* See `man 3 localtime` (convert timestamp into time structure in current timezone)  
* See `man 3 strftime` (format time structure into string)  

### Representing database records in C  

You must define a **`struct Record`** to represent a single line (record) from the CSV file (database). It must have one member for each of the fields of the record described above:  
* The "handle" and "comment" fields must be character arrays (not pointers) with sizes 32 and 64 respectively.  
* The "follower count" and "date last modified" fields must be of type `long unsigned int`.  

### Representing the database itself in C  

You must define a **`struct Database`** to represent a whole database. This will be an implementation of dynamic arrays, i.e., arrays that can "grow" during runtime, similar to the `ArrayList` class in Java or Python's built-in `list`.  

A dynamic array has three attributes: a pointer to an underlying (fixed-size) array, an integer called the capacity, and an integer called the size. The capacity is the length of the underlying array, and the size is the count of elements actually stored inside that array.  

When we want to add an item to the end of a dynamic array, we have to check if there's space left in the underlying array by comparing the size and the capacity. If the size is less than the capacity, then we can treat the size as the index at which to write the new item, then increment the size. Else, when the size has reached the capacity, a new underlying array with double the capacity is allocated, the elements from the old array are copied to the new array, and the old array's memory is freed, before proceeding as before.  

You must implement the following functions for handling the dynamic array:  
```c
typedef struct Database { /* fill this in */ } Database;

Database db_create();
// The database must have initial size 0 and capacity 4.

void db_append(Database *db, Record const *item);
// Copies the record pointed to by item to the end of the database.
// This is where you need to implement the resizing logic described above.

Record *db_index(Database *db, int index);
// Returns a pointer to the item in the database at the given index.
// You need to check the bounds of the index.

Record *db_lookup(Database *db, char const *handle);
// Returns a pointer to the first item in the database whose handle
// field equals the given value.

void db_free(Database *db);
// Releases the memory held by the underlying array.
// After calling this, the database can no longer be used.
```  

To implement these functions, you will need to use some of the standard library functions for memory management: check out `malloc`, `calloc`, `realloc`, and `free`. As usual, you can check the documentation for these with, e.g., `man 3 malloc`.  

### Reading and writing CSV files  

When the database application starts, it will load the file `database.csv` into memory, populating a `Database` object. When the application runs, the user will be able to command it to write the database. You will implement the following functions that accomplish reading and writing the whole database:  
```c
void db_load_csv(Database *db, char const *path);
// Appends the records read from the file at 'path'
// into the already initialized database 'db'.
// (The given database does not have to be empty.)

void db_write_csv(Database *db, char const *path);
// Overwrites the file located at 'path' with the
// contents of the database, represented in CSV format.
```  

Of course, reading the database can be decomposed into two subproblems: parsing a single line of the CSV file into a `Record` structure versus looping over all the lines in the file to populate the whole database. Your code must reflect this separation of concerns by implementing and using the following function:  
```c
Record parse_record(char const *line);
// Parses a single line of CSV data into one Record.
```  

You must use the following standard library functions to implement the functions in this section:  
* `fopen` to open files for reading or writing. You must call `fclose` on these when you finish reading or writing.  
* `getline` reads a line from a stream. You must be careful to properly free any buffers that this function might allocate for you.  
* `fprintf` writes formatted data to a given stream.  
* `strtok` is used to break up a string according to a delimiter, such as `,`.  

As always, check the documentation in the man pages, e.g., `man 3 getline`.  

### User interactions with the database  

The user manipulates the data in the database via an interactive prompt. The below example session illustrates how this should work. Each line beginning with `>` is a prompt, and my input is given after it.  

```plaintext
cs206@teach-node-04:~$ ./igdb
Loaded 5 records.
> list
HANDLE    | FOLLOWERS | LAST MODIFIED   | COMMENT
---|---|---|---
@spottedmcgill   | 14900    | 2024-03-15 17:03 | a bit cringe tbh
@foo    | 420    | 2024-03-13 13:37 | foo is foo
@bar    | 8008135   | 2024-03-14 20:03 | go to bar
@foobar    | 8008555   | 2024-03-15 17:01 | foo + bar = foobar
@quux    | 1234567   | 2024-03-16 16:06 | how to pronounce quux?
> add @zzzz 98765
Comment> sleeping in is great zzzz
> list
HANDLE    | FOLLOWERS | LAST MODIFIED   | COMMENT
---|---|---|---
@spottedmcgill   | 14900    | 2024-03-15 17:03 | a bit cringe tbh
@foo    | 420    | 2024-03-13 13:37 | foo is foo
@bar    | 8008135   | 2024-03-14 20:03 | go to bar
@foobar    | 8008555   | 2024-03-15 17:01 | foo + bar = foobar
@quux    | 1234567   | 2024-03-15 17:03 | how to pronounce quux?
@zzzz    | 98765    | 2024-03-15 17:08 | sleeping in is great zzzz
> update @bar 0
Comment> !!|account deleted!!!
> add
Error: usage: add HANDLE FOLLOWERS
> add @looooooooooooooooooooooong.name 12345
Error: handle too long.
> add @short.name 12345
Comment> ummm, this is a comment
Error: comment cannot contain commas.
> add @short.name lmao
Error: follower count must be an integer
> list
HANDLE    | FOLLOWERS | LAST MODIFIED   | COMMENT
---|---|---|---
@spottedmcgill   | 14900    | 2024-03-15 17:03 | a bit cringe tbh
@foo    | 420    | 2024-03-13 13:37 | foo is foo
@bar    | 0    | 2024-03-15 17:09 | !!|account deleted!!!
@foobar    | 8008555   | 2024-03-15 17:01 | foo + bar = foobar
@quux    | 1234567   | 2024-03-15 17:03 | how to pronounce quux?
@zzzz    | 98765    | 2024-03-15 17:08 | sleeping in is great zzzz
> update @wow 12345
Error: no entry with handle @wow
> add @spottedmcgill 12345
Error: handle @spottedmcgill already exists.
> exit
Error: you did not save your changes. Use `exit fr` to force exiting anyway.
> save
Wrote 6 records.
> exit
cs206@teach-node-04:~$
```  

Here is a detailed description of the commands that your interactive mode must support:  
- **`list`** – print out the whole database formatted as a table. For the widths of the columns, you can choose a fixed width, but make sure that the output always looks like a decent table. For instance, if you choose a fixed width of 20 characters for the handle, but the handle is 25 characters long, you should truncate the remaining extra characters from the handle to make it fit in the column. The same applies to the comment. This can be accomplished using the “width” and “precision” modifiers for the `%s` directive of `printf`.  
- **`add HANDLE FOLLOWERS`** – adds a new entry to the end of the database. That handle must not already exist in the database. A follow-up prompt is generated to ask the user for the value of the comment field.  
- **`update HANDLE FOLLOWERS`** – updates an existing entry for the given handle. An entry for that handle must be present. A follow-up prompt is generated to ask the user for the value of the comment field.  
- **`sort`** – without any parameters, writes the database out to the file `database.csv` in sorted order.  
- **`save`** – writes the database out to the file `database.csv` in whatever order the array is currently in.  
- **`exit`** – quits the program, but warns the user about unsaved changes if any and does not terminate the program.  

As in the previous assignment, your implementation must be robust in the face of user input. Therefore, for things such as integers written by the user in prompts, you will need to use `strtol` as in the previous assignment to ensure that valid input is given.  

However, you may assume that the CSV file is well-formed, so you do not need to validate, for instance, that the value stored in the follower count column contains only digits.  

## Extra Work for a Group of 4 Students

If your team has 4 students, then your program must also implement the following feature:

- **`find`** – as in `find HANDLE`, displays the same table as `list` does but with only the information from HANDLE if it exists, otherwise it does not display the table and outputs Not Found.  
- **`swap`** – as in `swap HANDLE1 HANDLE2`, changes the order of these two records, if they exist. If one or both do not exist, then the error message Not Found is displayed, otherwise the two records swap cell positions in the array.  

## Submission Instructions
After completing the assignment and finalizing your files:  

1. Make sure to **merge** and **push** your work from your private mimi account to the shared repo, if you have not already done so.
2. Make sure the code in the main branch of the shared repo runs. Login to the shared account and run the code in the src directory.
3. Verify that everyone's information is present by running **git branch** to see everyone's branch names, and do **git log** in main and in each branch to see if it is as you expect.
4. There is nothing more to do. The TAs will look at you work from the shared account.

If you need to make changes after committing, repeat the steps above with updated files.  

## How it will be graded

- Shared account setup correctly (has project subdirectory & git repo).
- Shared repo populated correctly (git branch, git log outputs as expected).
- more than 3 commits per person and more than 1 merge per person.
- Program runs correctly from shared repo using the testing script.
- Source code uses IPACS (TAs will open each file to confirm this).
- The readme.txt file contains student names, ID numbers, and the work assigned to them.
- TA will confirm that the array is actually an ArrayList-like implementation.
- TA will confirm that the CSV file updates as expected.

## Deadline Information  
At midnight on 11 April 2025 (so one minute after 11:59pm deadline on 11 April 2025), a script will copy the shared `project` directory, and that will be your submission.  

To allow for late submissions according to the policy outlined in the syllabus, the script will also make copies at midnight on the next two days after the 11th of April, 2025.  

If you intend to submit late, we **strongly** encourage you to read the policy carefully in the syllabus. You will lose points.  

## Food For Thought!  
These questions are optional but will help you think critically about systems programming challenges and advanced C techniques.  

1. **Handling Corrupted CSV Files**  
   The starter code assumes CSV files are well-formed. How might you modify `db_load_csv` to detect and handle malformed lines (e.g., missing fields, invalid timestamps, or forbidden characters in comments)? Could you log errors while still loading valid records?  

2. **Undo/Redo Functionality**  
   How might you design a system to track changes to the database, allowing users to undo accidental modifications? Would you log changes to a file or keep an in-memory history stack?  

3. **Concurrent Database Access**  
   What happens if two users run `igdb` simultaneously and both modify `database.csv`? How could you use file locking (e.g., `flock`) to prevent data corruption?  

4. **Efficient Search**  
   `db_lookup` uses linear search. If the database were sorted by handle, how could you implement binary search? Would the tradeoff between pre-sorting and faster lookups be worthwhile?  

5.  **Alternative Storage Formats**  
    CSV is human-readable but inefficient for large datasets. How could you adapt `db_write_csv` to serialize records in binary format? What tradeoffs would this introduce?  
